# TODO
#  - bundles msgpack headers to 3.2.0
#
# Conditional build:
%bcond_without	tests		# build without tests

%define		php_name	php%{?php_suffix}
%define		modname	msgpack
Summary:	PHP extension for interfacing with MessagePack
Name:		%{php_name}-pecl-%{modname}
# For PHP < 7, see 0.5.x branch
Version:	2.1.0
Release:	1
License:	PHP 3.01
Group:		Development/Languages/PHP
Source0:	https://pecl.php.net/get/%{modname}-%{version}.tgz
# Source0-md5:	901960fda542dec313ab4d89bd63d06d
URL:		https://pecl.php.net/package/msgpack/
BuildRequires:	%{php_name}-devel >= 4:7.0.0
BuildRequires:	rpmbuild(macros) >= 1.666
%if %{with tests}
BuildRequires:	%{php_name}-cli
BuildRequires:	%{php_name}-pcre
BuildRequires:	%{php_name}-session
BuildRequires:	%{php_name}-spl
%endif
%{?requires_php_extension}
Requires:	%{php_name}-session
Provides:	php(msgpack) = %{version}
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%description
This extension provide API for communicating with MessagePack
serialization.

MessagePack is a binary-based efficient object serialization library.
It enables to exchange structured objects between many languages like
JSON. But unlike JSON, it is very fast and small.

%package devel
Summary:	MessagePack developer files (header)
Group:		Development/Libraries
Requires:	%{php_name}-devel
# does not require base

%description devel
These are the files needed to compile programs using MessagePack.

%prep
%setup -qc
mv %{modname}-%{version}/* .

# https://github.com/msgpack/msgpack-php/issues/110
rm tests/040*.phpt

%build
phpize
%configure
%{__make}

%if %{with tests}
# simple module load test
%{__php} -n -q \
	-d extension_dir=modules \
	-d extension=%{php_extensiondir}/pcre.so \
	-d extension=%{php_extensiondir}/spl.so \
	-d extension=%{php_extensiondir}/session.so \
	-d extension=%{modname}.so \
	-m > modules.log
grep %{modname} modules.log

cat <<'EOF' > run-tests.sh
#!/bin/sh
export NO_INTERACTION=1 REPORT_EXIT_STATUS=1 MALLOC_CHECK_=2
exec %{__make} test \
	PHP_EXECUTABLE=%{__php} \
	PHP_TEST_SHARED_SYSTEM_EXTENSIONS="pcre spl session" \
	RUN_TESTS_SETTINGS="-q $*"
EOF
chmod +x run-tests.sh

./run-tests.sh
%endif

%install
rm -rf $RPM_BUILD_ROOT
%{__make} install \
	EXTENSION_DIR=%{php_extensiondir} \
	INSTALL_ROOT=$RPM_BUILD_ROOT

install -d $RPM_BUILD_ROOT%{php_sysconfdir}/conf.d
cat <<'EOF' > $RPM_BUILD_ROOT%{php_sysconfdir}/conf.d/%{modname}.ini
; Enable %{modname} extension module
extension=%{modname}.so
EOF

%clean
rm -rf $RPM_BUILD_ROOT

%post
%php_webserver_restart

%postun
if [ "$1" = 0 ]; then
	%php_webserver_restart
fi

%files
%defattr(644,root,root,755)
%doc CREDITS EXPERIMENTAL
%config(noreplace) %verify(not md5 mtime size) %{php_sysconfdir}/conf.d/%{modname}.ini
%attr(755,root,root) %{php_extensiondir}/%{modname}.so

%files devel
%defattr(644,root,root,755)
%{_includedir}/php/ext/%{modname}
%changelog
* Wed Jul 15 2020 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/php-pecl-msgpack.git;a=log;h=auto/th/php-pecl-msgpack-2.1.0-1

* Wed Jul 15 2020 Elan Ruusamäe <glen@pld-linux.org> 4387247
- Up to 2.1.0

* Wed Mar 01 2017 Patryk Szczygłowski <patryk@patryk.net> 6ee0a9a
- up to 2.0.2

* Tue Nov 22 2016 Elan Ruusamäe <glen@delfi.ee> 9cd71d6
- tests/040c.phpt fails on x86_64 builder as well

* Tue Nov 22 2016 Elan Ruusamäe <glen@delfi.ee> c6b639a
- add -devel package

* Tue Nov 22 2016 Elan Ruusamäe <glen@delfi.ee> 6995855
- drop tests/040*.phpt

* Tue Nov 22 2016 Elan Ruusamäe <glen@delfi.ee> 901929e
- this is php >= 7.0 version only

* Tue Nov 22 2016 Elan Ruusamäe <glen@delfi.ee> 8ba04bf
- disable tests/041

* Tue Nov 22 2016 Elan Ruusamäe <glen@delfi.ee> 0a9c573
- add run-test wrapper

* Tue Nov 22 2016 Elan Ruusamäe <glen@delfi.ee> 89bb337
- 2.0.1; php7 support

* Wed Jan 21 2015 Elan Ruusamäe <glen@delfi.ee> 658f850
- pcre for tests on i486/i686

* Wed Jan 21 2015 Elan Ruusamäe <glen@delfi.ee> 1637b07
- new, version 0.5.5

